<!--
  -  Copyright 2020 Huawei Technologies Co., Ltd.
  -
  -  Licensed under the Apache License, Version 2.0 (the "License");
  -  you may not use this file except in compliance with the License.
  -  You may obtain a copy of the License at
  -
  -      http://www.apache.org/licenses/LICENSE-2.0
  -
  -  Unless required by applicable law or agreed to in writing, software
  -  distributed under the License is distributed on an "AS IS" BASIS,
  -  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  -  See the License for the specific language governing permissions and
  -  limitations under the License.
  -->

<template>
  <div class="navgation">
    <div
      class="logo lt"
      @click="jumpLogoTo"
    >
      <img
        src="../assets/images/logo.png"
        alt=""
      >
      <span> | {{ $t('nav.lsms') }}</span>
    </div>
    <!-- <div>
      <Topbar :json-data="jsonData" />
    </div> -->
    <div class="nav-tabs rt">
      <div class="user rt">
        <span
          @click="jumpTo('/guest/home')"
          v-if="isLogin && !isGuest"
        >Edge Gallery</span>
        <!--<span
          @click="beforeLogout()"
          v-if="isLogin"
        >{{ $t('login.logout') }}</span>-->
        <span
          @click="jumpTo('/login')"
          v-if="isLogin === false && isLoginPage === false"
        >{{ $t('login.login') }}</span>
        <!--<span
          class="el-icon-question"
          style="font-size:20px;text-decoration:none"
          @click="jumpTo('/help')"
          title="help"
          v-if="isLogin && !isHelp"
        />-->
        <el-dropdown
          @command="handleCommand"
          v-if="isLogin"
        >
          <span
            class="el-dropdown-link"
            style="font-weight:bold;font-size:15px;"
          >
            Hi {{ loginName }}<i class="el-icon-caret-bottom el-icon--right" />
          </span>
          <el-dropdown-menu
            slot="dropdown"
            placement="bottom"
            style="margin-top:-10px"
          >
            <el-dropdown-item command="contact">
              Contact Us
            </el-dropdown-item>
            <el-dropdown-item command="help">
              Help
            </el-dropdown-item>
            <el-dropdown-item command="logout">
              Logout
            </el-dropdown-item>
          </el-dropdown-menu>
        </el-dropdown>
        <!--<span
          @click="changeLang"
        >{{ language }}</span>-->
      </div>
    </div>
  </div>
</template>

<script>
import NavData from '../data/NavData.js'
import NavDataCn from '../data/NavDataCn.js'
export default {
  name: 'Navgation',
  components: {
  },
  data () {
    return {
      isLogin: false,
      loginPage: '',
      jsonData: [],
      language: '简体中文',
      isLoginPage: true,
      isGuest: false,
      isHelp: false,
      loginName: ''
    }
  },
  watch: {
    $route (to, from) {
      this.isHelp = false
      if (to.path === '/login' || to.path === '/') {
        this.isLoginPage = true
      } else {
        this.isGuest = false
        if (to.path === '/guest/home') {
          this.isGuest = true
        }
        if (to.path === '/help') {
          this.isHelp = true
        }
        this.isLoginPage = false
      }
      sessionStorage.setItem('before_route', to.path)
      let user = sessionStorage.getItem('user')
      if (user === null || user === '') {
        this.isLogin = false
      } else {
        this.isLogin = true
      }
      this.loginName = JSON.parse(user).username
    }
  },
  mounted () {
    // this.jsonData = NavData
    this.language = '简体中文'
    // user.getUserInfo().then(res => {
    //  sessionStorage.setItem('userId', res.data.userId)
    //  sessionStorage.setItem('access_token', res.data.accessToken)
    //  sessionStorage.setItem('isSecureBackend', res.data.isSecureBackend)
    //  this.loginPage = res.data.loginPage
    // })
    let user = sessionStorage.getItem('user')
    if (user === null || user === '') {
      this.isLogin = false
      if (this.$route.path === '/login') {
        this.isLoginPage = true
      }
    } else {
      this.isLogin = true
    }
    this.loginName = JSON.parse(user).username
  },
  methods: {
    handleCommand (command) {
      if (command === 'logout') {
        this.beforeLogout()
      } else if (command === 'help') {
        this.jumpTo('/help')
      } else {
        window.open('https://web.whatsapp.com')
      }
    },
    jumpTo (path) {
      if (this.$route.path !== path) {
        this.$router.push(path)
      }
    },
    os () {
      let UserAgent = navigator.userAgent.toLowerCase()
      return {
        isWindows: /windows/.test(UserAgent),
        isMac: /mac/.test(UserAgent)
      }
    },
    changeLang () {
      let language
      if (this.language === 'English') {
        this.language = '简体中文'
        language = 'cn'
        this.jsonData = NavData
      } else {
        this.language = 'English'
        language = 'en'
        this.jsonData = NavDataCn
      }
      this.$i18n.locale = language
      let appDom = document.getElementById('app')
      if (language === 'en') {
        appDom.style.fontFamily = 'Huaweisans, Arial, Microsoft YaHei, FZLTXHJW, Microsoft JhengHei, sans-serif'
      } else {
        if (this.os.isMac) {
          appDom.style.fontFamily = 'PingFang, FZLTXHJW, Hiragino Sans GB, Microsoft YaHei, FZLTXHJW, Microsoft JhengHei, sans-serif'
        } else {
          appDom.style.fontFamily = 'Microsoft YaHei, FZLTXHJW, Microsoft JhengHei, sans-serif'
        }
      }
    },
    beforeLogout () {
      this.$confirm(this.$t('nav.logoutTip'), this.$t('common.warning'), {
        confirmButtonText: this.$t('common.confirm'),
        cancelButtonText: this.$t('common.cancel'),
        type: 'warning'
      }).then(() => {
        this.logout()
      })
    },
    jumpLogoTo () {
      try {
        switch (sessionStorage.getItem('role').toLowerCase()) {
          case 'administrator':
            this.jumpTo('/administrator/home')
            break
          case 'appdeveloper':
            this.jumpTo('/app/home')
            break
          case 'communitydeveloper':
            this.jumpTo('/community/home')
            break
          default:
            this.jumpTo('/login')
            this.isLoginPage = true
        }
      } catch {
        this.isLoginPage = true
        this.jumpTo('/login')
      }
    },
    logout () {
      // user.logout().then(res => {
      //  window.location.href = window.location.href.indexOf('https') > -1
      //    ? this.loginPage + '&return_to=' + 'https://' + window.location.host
      //    : this.loginPage + '&return_to=' + 'http://' + window.location.host
      // }).catch(error => {
      //  this.$message.error(error.message)
      // })
      sessionStorage.setItem('user', '')
      sessionStorage.setItem('role', '')
      this.jumpTo('/')
    }
  }
}
</script>

<style lang='less' scoped>
.navgation{
  background: #282B33;
  height: 65px;
  top: 0px;
  width: 100%;
  position: fixed;
  z-index: 2;
  .logo{
    height:65px;
    width:430px;
    line-height: 65px;
    margin-left:17px;
    img{
      position: relative;
      top: 0px;
      width:150px;
      cursor: pointer;
    }
    span{
      position: relative;
      top:-28px;
      font-size: 14px;
      color:#ffffff;
      left:20px;
      cursor:pointer;
    }
    span.blue{
      color:#409EFF;
    }
  }
  .language {
    display: inline-block;
    line-height: 65px;
    font-size: 14px;
    color: #6c92fa;
    span {
      width:60px!important;
      top:3px!important;
    }
    span:hover {
      text-decoration: underline;
    }
  }
  .user {
    display: inline-block;
    line-height: 65px;
    font-size: 14px;
    color: #6c92fa;
    span {
      top:3px!important;
      cursor: pointer;
      text-decoration: underline
    }
    span:hover {
      text-decoration: underline;
    }
  }
  .nav-tabs{
    height:100%;
    font-size:20px;
    line-height: 50px;
    margin-right: 10px;
    span{
      display: inline-block;
      height:24px;
      margin-right: 20px;
      position: relative;
      top:8px;
      cursor:pointer;
      color:#f5f5f5;
    }
    span.el-icon-user-solid.blue{
      color:#409EFF;
    }
  .pop-txt{
    font-size: 21px;
    padding: 10%;
  }
  .promt-actions{
    text-align: center;
    padding: 2%;
  }
  .okbtn{
    font-size: 20px;
  }
  }
}
</style>
